/********************************************************/
/*		soft object deformation simurator				*/
/*										FEM model		*/
/*										ver.1.0		*/
/*			Last updata:2006/09/13	Takashi Ikuta		*/
/********************************************************/
/*	<<Updata Information>>							*/
/*	2̓mFς							*/
/*	΂߃GbWׂ͂̕čォE		*/
/*	Lumped Inertia Matrix Model						*/
/*	wide=1,height=1̏ꍇmFς			*/
/*	elastic,voigt,maxwell,and three-element model	*/
/*	V~[V̌oߎԕ\ǉ				*/
/*	V~[VvZʂ̍팸					*/
/*	compValueύX(vOC)(05/10/12)			*/
/*	ψʃvOǉ(05/10/12)				*/
/*	ψʁCO͈֐(05/10/13)			*/
/*	f[^擾Ԋuݒł悤ɂ(05/10/13)	*/
/*	ψʕێvOǉ(05/10/16)			*/
/*	2݂̂̌ύX\ɂ(05/10/20)		*/
/*	ڑs񐶐vOǉ(05/10/26)		*/
/*	iq_WCԍCOp`vf_ԍ		*/

#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <windows.h>
#include <time.h>
#include "RK.h"
#include "data.h"
#include "func.h"
#include "geodata.h"
#include "structdata.h"

static int sel_b;

static void differential(int n, double x[], double t, double value[], struct geo_data geo)
{
	int q = 0;
	int r = 0;

	static double	FexX[node_Num]	={0.0};		//Ox
	static double	FexY[node_Num]	={0.0};		//Oy

	double	FX[node_Num] = {0.0};		//Op`vfό`ɂ锭
	double	FY[node_Num] = {0.0};
	double	CSMX[node_Num];				//ʍSpCSMϐ
	double	CSMY[node_Num];

	double MCSMX[node_Num];				//ψʗpCSMϐ
	double MCSMY[node_Num];

	double MX[node_Num] = {0.0};		//svZpϐ
	double MY[node_Num] = {0.0};

	double	npx[node_Num];				//_W
	double	npy[node_Num];
	double	nsx[node_Num];				//_ψʑx
	double	nsy[node_Num];
	double	wlax[node_Num];				//for maxwell and three-element model
	double	wlay[node_Num];
	double	wmux[node_Num];
	double	wmuy[node_Num];
	double	LMX[wide+1];				//ʍSCSMɂS
	double	LMY[wide+1];

	for(q=0;q<node_Num;q++)
	{
		npx[q]	= x[2*q+(0*node_Num)];
		npy[q]	= x[2*q+(0*node_Num+1)];
		nsx[q]	= x[2*q+(2*node_Num)];
		nsy[q]	= x[2*q+(2*node_Num+1)];
		wlax[q]	= x[2*q+(4*node_Num)];
		wlay[q]	= x[2*q+(4*node_Num+1)];
		wmux[q]	= x[2*q+(6*node_Num)];
		wmuy[q]	= x[2*q+(6*node_Num+1)];
	}
	for(q=0;q<wide+1;q++)
	{
		LMX[q] = x[2*q+(8*node_Num)];
		LMY[q] = x[2*q+(8*node_Num+1)];
	}

	/*------<<select>>computing of model force(e_ɂ郂f͂̌vZCf̑I)----*/
	switch(sel_b)
	{
	case 1:
		viscoelastic_Force(FX,FY,nsx,nsy,npx,npy,t,geo);					//voigt
		break;
	case 2:
		viscoplastic_Force(FX,FY,wlax,wlay,wmux,wmuy,value,nsx,nsy,t,geo);	//maxwell
		break;
	case 3:
		threeElement_Force(FX,FY,wlax,wlay,wmux,wmuy,value,nsx,nsy,t,geo);	//three-element
		break;
	case 4:
		elastic_Force(FX,FY,npx,npy,t,geo);									//elastic
		break;
	default:
		printf("\nERROR! Prease ENTER the KEY from 1 to 4!\n");
		exit(1);
		break;
	}
	/*--------------------------------------------------------------------------------------------*/

#if 0
	/*------computing of nodal force(sKv)-----------*/
//	nodal_Force(FmwX,FmwY,FX,FY,FexX,FexY);
	/*-------------------------------------------------*/
#endif

	/*-------O͈֐(ψʂꍇ̓RgAEg邱)-----*/
//	add_exforce(FX,FY,FexX,FexY,t);
	/*----------------------------------------------------------------------*/

	/*------computing of analysis value---------------------------------------------------------------------------------*/
	compValue2(FX,FY,nsx,nsy,npx,npy,CSMX,CSMY,x,value,LMX,LMY,MX,MY,t,MCSMX,MCSMY,geo);	//V(gpDψʍ)
	/*------------------------------------------------------------------------------------------------------------------*/

	/*---------ψʗp֐(O͂ꍇ̓RgAEg邱)----*/
	add_csmmove(npx,npy,nsx,nsy,value,MCSMX,MCSMY,t);
	/*---------------------------------------------------------------------*/

	//-----------for debug----------------
	//if(x[node_Num*2-2]>=1000 || x[node_Num*2-2]<=-1000)
	if(npy[node_Num]<-1000.0)
	{
		printf("ERROR\r");
	}
	//------------------------------------
}

void main()
{
	double	startTime	= timeGetTime();
	long	kcnt;
	double	t, dt, tend;
	int		cnt			= 0;
	int		sel_a;
	double	x[NumVars]	= {0.0};
	char	*filename	= "result.dat";
	char	*filename2	= "geodata.dat";
	char	*filename3	= "tridata.dat";
	FILE	*fd,*fg,*ft;
	
	if ((fd = fopen(filename,"w")) == NULL) {
		fprintf(stderr, "cannot open %s\n", filename);
		exit(1);
	}

	if ((fg = fopen(filename2,"w")) == NULL) {
		fprintf(stderr, "cannot open %s\n", filename2);
		exit(1);
	}

	if ((ft = fopen(filename3,"w")) == NULL) {
		fprintf(stderr, "cannot open %s\n", filename3);
		exit(1);
	}

	dt = s_time;							//sampling time

	/* kcnt * dt = 10 [sec] */

	/*	sʕ\p(p[^o)	*/
	printf("Simulation of 2D soft object deformation of a rectangular object(FEM MODEL)\n");
	printf("Ver.%lf\n\n",version);
	printf("\tsimulation time\t: %d[s]\n",sim_time);
	printf("\tsampling time\t: %lf[s](%lf[ms])(Runge-Kutta-Method)\n",s_time,s_time*1000);
//	printf("\tloop count\t: %d\n\n",kcnt);
	printf("\tobject\t\t: %d~%d[mesh]\n\tnodes\t\t: %d\n",wide,height,node_Num);
	printf("\tobject size\t: %.0lf[mm]~%.0lf[mm]\n\n\n",wide*tri_wide*1000,height*tri_height*1000);
	printf("\tPoisson's ratio\t\t= %lf\n\tYoung's modulous\t= %lf\n\tViscous modulous\t= %lf\n\n",Nela,E,C);
//	printf("\tomega\t\t= %lf\n\tLela\t\t= %lf\n\tMela\t\t= %lf\n\tLvis\t\t= %lf\n\tMvis\t\t= %lf\n",omega,Lela,Mela,Lvis,Mvis);
	printf("\tmass\t\t= %lf[kg](nodal mass\t= %lf)\n\tdensity\t\t= %lf\n\n",MASS,MASS/(node_Num),D);
	printf("Select computing method(ENTER the number  1 or 2)\n1:Runge-Kutta-Fehelberg\n2:Runge-Kutta\n");
	printf("ENTER the number:");
	scanf("%d",&sel_a);
	switch(sel_a)
	{
		case 1:
			printf("\nYou choose:\tRunge-Kutta-Fehelberg\n");
			break;
		case 2:
			printf("\nYou choose:\tRunge-Kutta\n");
			break;
		default:
			printf("\nERROR! Prease ENTER the 1 or 2 KEY!\n");
			exit(1);
			break;
	}
	printf("\nSelect computing method(ENTER the number  from 1 to 4)\n1:Voigt\n2:Maxwell\n3:Three-Element\n4:Elastic\n");
	printf("ENTER the number:");
	scanf("%d",&sel_b);
	switch(sel_b)
	{
	case 1:
		printf("\nYou choose:\tVoigt\n\n");
		break;
	case 2:
		printf("\nYou choose:\tMaxwell\n\n");
		break;
	case 3:
		printf("\nYou choose:\tThree-Element\n\n");
		break;
	case 4:
		printf("\nYou choose:\tElastic\n\n");
		break;
	default:
		printf("\nERROR! Prease ENTER the KEY from 1 to 4!\n");
		exit(1);
		break;
	}

	printf("Start simulation\n");

	/* initial value */
	t = 0.0;
	tend = sim_time;

	kcnt = (int)(sim_time/dt);//1000;		//loop count

	static struct geo_data geo;		//􉽏p\̐錾

	//`̂̊iq_WCOp`vf̒_ԍW[-----
	make_GeoData(fg, ft, &geo);
	//---------------------------------------------------------------

	//Op`vf̕ڑsCʐρC[̒萔W[-----
	make_MatandArea(fg, &geo);
	//---------------------------------------------------------------

	switch(sel_a)
	{
		case 1:
			RungeKuttaFehlbergAdaptivefprint(fd, NumVars, x, t, dt, &cnt);	// print initial values
			RungeKuttaFehlbergAdaptive(fd, NumVars, x, differential, &t, &dt, tend, kcnt, geo, &cnt);
			break;
		case 2:
			RungeKuttafprint(fd, NumVars, x, t);	// print initial values
			RungeKutta(fd, NumVars, x, differential, &t, dt, kcnt, geo);
			break;
		default:
			printf("\nERROR! Prease ENTER the 1 or 2 KEY!\n");
			exit(1);
			break;
	}

	double Time = timeGetTime();
	printf("\n\n");
	printf("End of simulation\treal time:%lf[s]\n",(Time-startTime)/CLOCKS_PER_SEC);
	printf("time per 1 loop(ave.) = %lf[ms]\n",(Time-startTime)/(kcnt));		//Runge-Kutta 1[v̕ώԕ\[ms]
	//Release:	about 0.138[ms] 
	//Debug:	about 0.48[ms]
	
	fclose(fd);
	fclose(fg);
}

