#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <windows.h>
#include <time.h>
#include "RK.h"
#include "data.h"
#include "func.h"
#include "structdata.h"

void threeElement_Force (double FX[],double FY[],double wlax[],double wlay[],double wmux[],double wmuy[],
						 double value[],double nsx[],double nsy[],double t,struct geo_data geo)
{
	int q,i,k = 0;

	int ti,tj,tk;
	
	double wlatemp[6] = {0.0};
	double wmutemp[6] = {0.0};
	double nstemp[6] = {0.0};
	
	for(i=0;i<tri_Num;i++)
	{
		ti = geo.triangle[i].point_i;
		tj = geo.triangle[i].point_j;
		tk = geo.triangle[i].point_k;

		wlatemp[0] = wlax[ti];
		wlatemp[1] = wlay[ti];
		wlatemp[2] = wlax[tj];
		wlatemp[3] = wlay[tj];
		wlatemp[4] = wlax[tk];
		wlatemp[5] = wlay[tk];

		wmutemp[0] = wmux[ti];
		wmutemp[1] = wmuy[ti];
		wmutemp[2] = wmux[tj];
		wmutemp[3] = wmuy[tj];
		wmutemp[4] = wmux[tk];
		wmutemp[5] = wmuy[tk];

		nstemp[0] = nsx[ti];
		nstemp[1] = nsy[ti];
		nstemp[2] = nsx[tj];
		nstemp[3] = nsy[tj];
		nstemp[4] = nsx[tk];
		nstemp[5] = nsy[tk];

		for(k=0;k<6;k++)
		{
			FX[ti] +=	geo.triangle[i].mat_lambda[0][k]*(wlatemp[k]+geo.triangle[i].Lvis*nstemp[k])+
						geo.triangle[i].mat_mu[0][k]*(wmutemp[k]+geo.triangle[i].Mvis*nstemp[k]);

			FY[ti] +=	geo.triangle[i].mat_lambda[1][k]*(wlatemp[k]+geo.triangle[i].Lvis*nstemp[k])+
						geo.triangle[i].mat_mu[1][k]*(wmutemp[k]+geo.triangle[i].Mvis*nstemp[k]);

			FX[tj] +=	geo.triangle[i].mat_lambda[2][k]*(wlatemp[k]+geo.triangle[i].Lvis*nstemp[k])+
						geo.triangle[i].mat_mu[2][k]*(wmutemp[k]+geo.triangle[i].Mvis*nstemp[k]);

			FY[tj] +=	geo.triangle[i].mat_lambda[3][k]*(wlatemp[k]+geo.triangle[i].Lvis*nstemp[k])+
						geo.triangle[i].mat_mu[3][k]*(wmutemp[k]+geo.triangle[i].Mvis*nstemp[k]);

			FX[tk] +=	geo.triangle[i].mat_lambda[4][k]*(wlatemp[k]+geo.triangle[i].Lvis*nstemp[k])+
						geo.triangle[i].mat_mu[4][k]*(wmutemp[k]+geo.triangle[i].Mvis*nstemp[k]);

			FY[tk] +=	geo.triangle[i].mat_lambda[5][k]*(wlatemp[k]+geo.triangle[i].Lvis*nstemp[k])+
						geo.triangle[i].mat_mu[5][k]*(wmutemp[k]+geo.triangle[i].Mvis*nstemp[k]);
						
		}
	}

	//ύXKv
	for(q=0;q<node_Num;q++)
	{
		value[2*q+(4*node_Num)]		= -(Lela/(Lvis+Ltvis))*(wlax[q]-Ltvis*nsx[q]);
		value[2*q+(4*node_Num+1)]	= -(Lela/(Lvis+Ltvis))*(wlay[q]-Ltvis*nsy[q]);
		value[2*q+(6*node_Num)]		= -(Mela/(Mvis+Mtvis))*(wmux[q]-Mtvis*nsx[q]);
		value[2*q+(6*node_Num+1)]	= -(Mela/(Mvis+Mtvis))*(wmuy[q]-Mtvis*nsy[q]);
	}
}